Index: loader/source/update.c
===================================================================
--- loader/source/update.c	(revision 542)
+++ loader/source/update.c	(working copy)
@@ -23,115 +23,205 @@
 #include <string.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <unistd.h>
-#include <malloc.h>
-#include <network.h>
-#include <zlib.h>
-#include <ogc/lwp_watchdog.h>
-
-#include "exi.h"
-#include "FPad.h"
-#include "font.h"
-#include "global.h"
-#include "http.h"
-#include "ssl.h"
-#include "menu.h"
-#include "update.h"
-#include "../../common/include/NintendontVersion.h"
-
-#include "ff_utf8.h"
-#include "unzip/miniunz.h"
-#include "unzip/ioapi.h"
-
-extern char launch_dir[MAXPATHLEN];
-
-typedef struct {
-	const char url[96];
+#include <unistd.h>
+#include <malloc.h>
+#include <network.h>
+
+#include <zlib.h>
+#include <ogc/lwp_watchdog.h>
+#include "ssl.h"
+#include "exi.h"
+#include "FPad.h"
+#include "font.h"
+#include "global.h"
+#include "http.h"
+#include "menu.h"
+#include "update.h"
+#include "ff_utf8.h"
+#include "unzip/miniunz.h"
+#include "unzip/ioapi.h"
+#include "../../common/include/NintendontVersion.h"
+
+extern char launch_dir[MAXPATHLEN];
+extern void changeToDefaultDrive();
+extern int ExitBoot;
+bool prev;
+
+typedef struct {
+	const char url[96];
 	const char text[30];
 	const char filename[30];
 	const u32 max_size;
 } downloads_t;
+
+typedef enum {
+	DOWNLOAD_NINTENDONT = 0,
+	DOWNLOAD_OTHER,
+	DOWNLOAD_BIOS,
+	DOWNLOAD_GAME,		
+	DOWNLOAD_LOADERTHEME,
+	DOWNLOAD_LEGACYTHEME,		
+	DOWNLOAD_APPTHEME,
+	DOWNLOAD_GRAD,
+	DOWNLOAD_SIMPLE,
+	DOWNLOAD_SINGLE,
+	DOWNLOAD_BLACK,		
+	DOWNLOAD_OLD,
+	DOWNLOAD_NOOLD,
+	DOWNLOAD_DEFAULTTHEME,
+	DOWNLOAD_VERSION
+} DOWNLOADS;
+
+static const downloads_t Downloads[] = {
+	{"http://send0r.de/Nintendont/MasterMod/boot.zip", "Updating Nintendont", "boot.zip", 0x400000}, // 4MB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB	
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB	
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB
+	{"http://send0r.de/Nintendont/MasterMod/NinBlack.zip", "Downloading Black Boot Screen", "", 0x8000}, // 32KB
+	{"http://send0r.de/Nintendont/MasterMod/Preview.zip", "Downloading Preview Pack", "Preview.zip", 0x400000}, // 4MB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400}, // 1KB
+	{"https://dl.dropboxusercontent.com/u/101209384/NintendontVersion.h", "Checking Latest Version", "", 0x400} // 1KB
+};
 
-typedef enum {
-	DOWNLOAD_NINTENDONT = 0,
-	DOWNLOAD_TITLES,
-	DOWNLOAD_CONTROLLERS,
-	DOWNLOAD_VERSION
-} DOWNLOADS;
-
-static const downloads_t Downloads[] = {
-	{"https://raw.githubusercontent.com/FIX94/Nintendont/master/loader/loader.dol", "Updating Nintendont", "boot.dol", 0x400000}, // 4MB
-	{"https://raw.githubusercontent.com/FIX94/Nintendont/master/nintendont/titles.txt", "Updating titles.txt", "titles.txt", 0x80000}, // 512KB
-	{"https://raw.githubusercontent.com/FIX94/Nintendont/master/controllerconfigs/controllers.zip", "Updating controllers.zip", "controllers.zip", 0x8000}, // 32KB
-	{"https://raw.githubusercontent.com/FIX94/Nintendont/master/common/include/NintendontVersion.h", "Checking Latest Version", "", 0x400} // 1KB
-};
-
-extern void changeToDefaultDrive();
-static int UnzipControllers(const void *buf, size_t fSize) {
-	char filepath[20];
-	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
-	static const char *unzip_directory = "/controllers";
-	unzFile uf = unzOpen(filepath);
-	if (!uf) {
-		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_CONTROLLERS].filename);
-		return -1;
-	}
-	gprintf("%s opened\n", Downloads[DOWNLOAD_CONTROLLERS].filename);
-	f_chdrive_char(UseSD ? "sd:" : "usb:");
-	f_mkdir_char(unzip_directory); // attempt to make dir
-	if (f_chdir_char(unzip_directory) != FR_OK) {
-		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
-		return -2;
-	}
-
-	if (extractZip(uf, 0, 1, 0)) {
-		gprintf("Failed to extract %s\r\n", filepath);
-		return -3;
-	}
-
-	unzCloseCurrentFile(uf);
-	unzClose(uf);
-	remove(Downloads[DOWNLOAD_CONTROLLERS].filename);
-	changeToDefaultDrive();
-	return 1;
+static int UnzipNintendont(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_NINTENDONT].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_NINTENDONT].filename);
+	//changeToDefaultDrive();
+	f_mkdir_char(unzip_directory); // attempt to make dir
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_NINTENDONT].filename);
+	changeToDefaultDrive();
+	return 1;
 }
-
-static inline bool LatestVersion(int *major, int *minor, int *current_line) {
-	u32 http_status = 0;
-	u8* outbuf = NULL;
-	u32 filesize;
-	int line = *current_line;
-
-	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[DOWNLOAD_VERSION].text);
-	UpdateScreen();
-	line++;
-	if(!http_request(Downloads[DOWNLOAD_VERSION].url, Downloads[DOWNLOAD_VERSION].max_size)) {
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Failed to retrieve version");
-		UpdateScreen();
-		*current_line = line;
-		return false;
-	}
-	
-
-	http_get_result(&http_status, &outbuf, &filesize);
-	
+
+static int UnzipBlack(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_BLACK].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_BLACK].filename);
+	changeToDefaultDrive();
+	f_mkdir_char(unzip_directory); // attempt to make dir
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_BLACK].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static int UnzipPreview(const void *buf, size_t fSize) {
+	char filepath[20];
+	snprintf(filepath,20,"%x+%x",(u32)buf,(u32)fSize);
+	static const char *unzip_directory = "/apps/Nintendont";
+	unzFile uf = unzOpen(filepath);
+	if (!uf) {
+		gprintf("Cannot open %s, aborting\r\n", Downloads[DOWNLOAD_OLD].filename);
+		return -1;
+	}
+	gprintf("%s opened\n", Downloads[DOWNLOAD_OLD].filename);
+	changeToDefaultDrive();
+	f_mkdir_char(unzip_directory); // attempt to make dir
+	if(f_chdir_char(unzip_directory) != FR_OK) {
+		gprintf("Error changing into %s, aborting\r\n", unzip_directory);
+		return -2;
+	}
+
+	if (extractZip(uf,0,1,0)) {
+		gprintf("Failed to extract %s\r\n", filepath);
+		return -3;
+	}
+
+	unzCloseCurrentFile(uf);
+	f_unlink_char(Downloads[DOWNLOAD_OLD].filename);
+	changeToDefaultDrive();
+	return 1;
+}
+
+static inline bool LatestVersion(int *major, int *minor, int *current_line) {
+	u32 http_status = 0;
+	u8* outbuf = NULL;
+	u32 filesize;
+	int line = *current_line;
+					if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[DOWNLOAD_VERSION].text);}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[DOWNLOAD_VERSION].text);}
+	UpdateScreen();
+	line++;
+	if(!http_request(Downloads[DOWNLOAD_VERSION].url, Downloads[DOWNLOAD_VERSION].max_size)) {
+				//		if (which_bg == BG_NONE)
+				//	{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Failed to retrieve version");}
+				//	else if (which_bg == BG_LEGACY)
+				//	{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Failed to retrieve version");}
+		UpdateScreen();
+		*current_line = line;
+		return true; //false;
+	}
+
+	http_get_result(&http_status, &outbuf, &filesize);
+	
 	if (((int)*outbuf & 0xF0000000) == 0xF0000000) 
 	{
 		if (outbuf != NULL) free(outbuf);
-		*current_line = line;
-		return false;
-	}
-	sscanf((char*)outbuf, " #ifndef %*s #define %*s #define NIN_MAJOR_VERSION %i #define NIN_MINOR_VERSION %i", major, minor);
-	gprintf("major = %i, minor = %i\r\n", *major, *minor);
-	if (outbuf != NULL) free(outbuf);
-	if ((*major <= NIN_MAJOR_VERSION) && (*minor <= NIN_MINOR_VERSION)) {
-		bool still_download = true;
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "You already have the latest version");
-		line++;
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Download anyway? (A: Yes, B: No)");
-		line++;
-		UpdateScreen();
-		while(true) {
+		*current_line = line;
+		return false;
+	}
+//	sscanf((char*)outbuf, " #ifndef %*s #define %*s #define NIN_MAJOR_VERSION %i #define NIN_MINOR_VERSION %i", major, minor);
+//	gprintf("major = %i, minor = %i\r\n", *major, *minor);
+	*major=3;
+	*minor=999;
+	if (outbuf != NULL) free(outbuf);
+	/*if ((*major <= NIN_MAJOR_VERSION) && (*minor <= NIN_MINOR_VERSION)) {
+		bool still_download = true;
+								if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "You already have the latest version");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "You already have the latest version");}
+		line++;
+								if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Download anyway? (A: Yes, B: No)");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Download anyway? (A: Yes, B: No)");}
+		line++;
+		UpdateScreen();
+		while(true) {
 			DrawBuffer();
 			FPAD_Update();
 			if (FPAD_Cancel(0)) {
@@ -146,13 +236,13 @@
 			GRRLIB_Render();
 		}
 		if(!still_download) {
-			*current_line = line;
-			return false;
-		}
-	}
-	*current_line = line;
-	return (*major + *minor) > 0;
-
+			*current_line = line;
+			return false;
+		}
+	} */
+	*current_line = line;
+	return (*major + *minor) > 0;
+
 }
 
 static s32 Download(DOWNLOADS download_number)  {
@@ -162,48 +252,58 @@
 	int ret, major = 0, minor = 0;
 	u32 http_status = 0;
 	u8* outbuf = NULL;
-	u32 filesize;
-	char filepath[MAXPATHLEN];
-	bool dir_argument_exists = strlen(launch_dir);
-
-	snprintf(filepath, sizeof(filepath), "%s%s",
-		dir_argument_exists ? launch_dir : "/apps/Nintendont/",
-		Downloads[download_number].filename);
-	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);
-	UpdateScreen();
-
-	// TODO: Use ioapi mem and skip writing the ZIP file to disk.
-	line++;
-	gprintf("Downloading %s to %s\r\n", Downloads[download_number].url, filepath);
-	ret = net_init();
-	if (ret < 0) {
-		gprintf("Failed to init network\r\n");
-		goto end;
-	}
-	gprintf("Network Initialized\r\n");
-	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");
-	UpdateScreen();
-	ssl_init(); //only once needed
-	line++;
-	if (download_number == DOWNLOAD_NINTENDONT) {
-		ret = LatestVersion(&major, &minor, &line);
-		if (!ret) {
-			PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Download Cancelled");
-			UpdateScreen();
-			if (outbuf != NULL) free(outbuf);
-			net_deinit();
-			sleep(4);
-			return 0;
-		}
-
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Downloading Nintendont v%i.%i", major, minor);
-		UpdateScreen();
-		line++;
-	}
-
-	int i;
-	for (i = 0; i <= 10; i++) {
-		ret = http_request(Downloads[download_number].url, Downloads[download_number].max_size);
+	u32 filesize;
+	char filepath[MAXPATHLEN];
+	bool dir_argument_exists = strlen(launch_dir);
+	if (download_number == 0)
+	snprintf(filepath, sizeof(filepath), "%s%s", dir_argument_exists ? launch_dir : "/apps/Nintendont/", Downloads[download_number].filename);
+	else
+	snprintf(filepath, sizeof(filepath), "%s%s", dir_argument_exists ? launch_dir : "./", Downloads[download_number].filename);
+	
+								if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, Downloads[download_number].text);}
+	UpdateScreen();
+	
+	line++;
+	gprintf("Downloading %s to %s\r\n", Downloads[download_number].url, filepath);
+	ret = net_init();
+	if(ret < 0) {
+		gprintf("Failed to init network\r\n");
+		goto end;
+	}
+	gprintf("Network Initialized\r\n");
+									if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Network Initialized");}
+	UpdateScreen();
+	ssl_init(); //only once needed
+	line++;
+	if (download_number == DOWNLOAD_NINTENDONT) {
+		ret = LatestVersion(&major, &minor, &line);
+		if (!ret) {
+										if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Download Cancelled");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*(line+1), "Download Cancelled");}
+			UpdateScreen();
+			if (outbuf != NULL) free(outbuf);
+			net_deinit();
+			sleep(4);
+			return 0;
+		}
+								if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Downloading MasterMod");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Downloading MasterMod");}
+		UpdateScreen();
+		line++;
+	}
+	int i;
+	for (i = 0; i <= 10; i++) {
+		ret = http_request(Downloads[download_number].url, Downloads[download_number].max_size);
 		if (ret) break;
 		if (i == 10) {
 			gprintf("Error making http request\r\n");
@@ -210,97 +310,236 @@
 			ret = -1;
 			goto end;
 		}
-	}
-
-	ret = http_get_result(&http_status, &outbuf, &filesize); 
-	if (((int)*outbuf & 0xF0000000) == 0xF0000000) {
-		ret = -2;
-		goto end;
-	}
-
-	PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Download Complete");
-	UpdateScreen();
-	line++;
-	if (!dir_argument_exists) {
+	}
+
+	ret = http_get_result(&http_status, &outbuf, &filesize); 
+	if(((int)*outbuf & 0xF0000000) == 0xF0000000) 
+	{
+		ret = -2;
+		goto end;
+	}
+									if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Download Complete");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Download Complete");}
+	UpdateScreen();
+	line++;
+	if (!dir_argument_exists) {
 		gprintf("Creating new directory\r\n");
 		f_mkdir_char("/apps");
-		f_mkdir_char("/apps/Nintendont");
-	}
-
-	// Write the file to disk.
-	if (download_number == DOWNLOAD_CONTROLLERS) {
-		// controllers.zip needs to be decompressed.
-		ret = UnzipControllers(outbuf, filesize);
-	}
-	else
-	{
-		FIL file;
-		if (f_open_char(&file, filepath, FA_WRITE|FA_CREATE_ALWAYS) != FR_OK) {
+		f_mkdir_char("/apps/Nintendont");
+	}
+	 if (download_number == DOWNLOAD_NINTENDONT) {ret = UnzipNintendont(outbuf, filesize);}
+else if (download_number == DOWNLOAD_BLACK) {ret = UnzipBlack(outbuf, filesize);}
+else if (download_number == DOWNLOAD_OLD) {
+		changeToDefaultDrive();
+		f_chdir_char("/");
+		f_mkdir_char("/apps");
+		f_mkdir_char("/apps/Nintendont");
+		f_rename_char( "/apps/Nintendont/Previewz", "/apps/Nintendont/Preview");
+		f_mkdir_char("/apps/Nintendont/Preview");
+		f_mkdir_char("/apps/Nintendont/Preview/bios");
+		f_mkdir_char("/apps/Nintendont/Preview/black");
+		f_mkdir_char("/apps/Nintendont/Preview/dark");
+		f_mkdir_char("/apps/Nintendont/Preview/game");
+		f_mkdir_char("/apps/Nintendont/Preview/grad");
+		f_mkdir_char("/apps/Nintendont/Preview/light");
+		f_mkdir_char("/apps/Nintendont/Preview/loader");
+		f_mkdir_char("/apps/Nintendont/Preview/single");
+		ret = UnzipPreview(outbuf, filesize);
+	}
+else
+	{
+		FIL file;
+		if (f_open_char(&file, filepath, FA_WRITE|FA_CREATE_ALWAYS) != FR_OK) {
 			gprintf("File Error\r\n");
 			ret = -3;
 			goto end;
 		} else {
-			UINT wrote;
-			f_write(&file, outbuf, filesize, &wrote);
-			f_close(&file);
-			ret = 1;
-		}
-	}
-	if (ret == 1) {
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");
-		UpdateScreen();
-		line++;
-	}
-
-end:
-	if (ret != 1)
-		PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*line, "Update Error: %i", ret);
-	else
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Restart Nintendont to complete update");
-	UpdateScreen();
-	if (outbuf != NULL) free(outbuf);
-	net_deinit();
-	sleep(4);
-	return ret;
-}
-
+			UINT wrote;
+			f_write(&file, outbuf, filesize, &wrote);
+			f_close(&file);
+			ret = 1;			
+		}
+	}
+	if (ret == 1) {
+										if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Update Complete");}
+		UpdateScreen();
+		line++;
+	}
+end:
+	if (ret != 1)
+		{
+			if (which_bg == BG_NONE)
+			PrintFormat(DEFAULT_SIZE, MAROON, MENU_POS_X, MENU_POS_Y + 20*line, "Update Error: %i", ret);
+			else if (which_bg == BG_LEGACY)
+			PrintFormat(DEFAULT_SIZE, YELLOW, MENU_POS_X, MENU_POS_Y + 20*line, "Update Error: %i", ret);
+		}
+	else if (download_number == DOWNLOAD_NINTENDONT)
+	{									if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*line, "Restart Nintendont to complete update");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*line, "Restart Nintendont to complete update");}}
+	else {}	
+	UpdateScreen();
+	if (outbuf != NULL) free(outbuf);
+	net_deinit();
+	sleep(3);
+	return ret;
+}
+
 void UpdateNintendont(void) {
 	int selected = 0;
-	u64 delay = ticks_to_millisecs(gettime()) + 500;
-	while(true) {
-		ClearScreen();
-		PrintInfo();
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download Nintendont");
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download titles.txt");
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download controllers.zip");
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Return to Settings");
-		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 35, MENU_POS_Y + 20*(5+selected), ARROW_RIGHT);
-		GRRLIB_Render();
-		FPAD_Update();
-		if (delay > ticks_to_millisecs(gettime())) continue;
-		if (FPAD_Start(1)) {
-			ShowMessageScreenAndExit("Returning to loader...", 0);
-		}
-		if (FPAD_OK(1)) {
-			if (selected <= DOWNLOAD_CONTROLLERS)
-				Download(selected);
-			else
-				break;
-		}
-		if (FPAD_Down(1)) {
-			delay = ticks_to_millisecs(gettime()) + 150;
-			selected++;
-			if (selected > 3) selected = 0;
-		}
-		if (FPAD_Up(1)) {
-			delay = ticks_to_millisecs(gettime()) + 150;
-			selected--;
-			if (selected < 0) selected = 3;
-		}
-		if (FPAD_Cancel(1)) {
-			break;
-		}
-	}
-	ClearScreen();
-	return;
-}
+	u64 delay = ticks_to_millisecs(gettime()) + 500;
+	while(true) {
+		ClearScreen();
+		if (f_chdir_char("/apps/Nintendont/Preview") == FR_OK)
+		prev = true;
+		else 
+		prev = false;
+		if (which_bg == BG_NONE)
+					{		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");		
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X, MENU_POS_Y + 20*2, "Updates & Themes Menu");
+		PrintFormat(15, BLACK, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");		
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Download Nintendont MasterMod (Latest Revision)");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download Nintendont (Official & Other Mods)");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download Extras (Titles, Controllers & Bios)");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download/Delete Custom Game Loader Themes");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Download Nintendont Loader Themes");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*9, "Download Nintendont Dark Themes");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Download Nintendont Light Themes");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*11, "Download Nintendont Gradient Themes");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*12, "Download Nintendont Black Themes");								
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*13, "Download Nintendont Unicolor Themes");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*14, "Use Black Screen on Game Boot");			
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*15, "Download Mastermod Preview Pack");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*16, "Mastermod Preview Pack: %s", prev ? "Enabled" : "Disabled");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*17, "Restore Default Theme");	
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 50, MENU_POS_Y + 20*18, "Exit Updates & Themes Menu");
+		PrintFormat(DEFAULT_SIZE, BLACK, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+					else if (which_bg == BG_LEGACY)
+					{		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y, "  Home: Exit");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*1, "  A   : Select");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 430, MENU_POS_Y + 20*2, "  B   : Back");		
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X, MENU_POS_Y + 20*2, "Updates & Themes Menu");
+		PrintFormat(15, WHITE, MENU_POS_X + 235, MENU_POS_Y + 20*21, "Y/2: Credits");		
+		PrintInfo();
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*4, "Download Nintendont MasterMod (Latest Revision)");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*5, "Download Nintendont (Official & Other Mods)");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*6, "Download Extras (Titles, Controllers & Bios)");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*7, "Download/Delete Custom Game Loader Themes");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*8, "Download Nintendont Loader Themes");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*9, "Download Nintendont Dark Themes");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*10, "Download Nintendont Light Themes");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*11, "Download Nintendont Gradient Themes");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*12, "Download Nintendont Black Themes");								
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*13, "Download Nintendont Unicolor Themes");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*14, "Use Black Screen on Game Boot");			
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*15, "Download Mastermod Preview Pack");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*16, "Mastermod Preview Pack: %s", prev ? "Enabled" : "Disabled");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*17, "Restore Default Theme");	
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 50, MENU_POS_Y + 20*18, "Exit Updates & Themes Menu");
+		PrintFormat(DEFAULT_SIZE, WHITE, MENU_POS_X + 35, MENU_POS_Y + 20*(4+selected), ARROW_RIGHT);}
+
+		GRRLIB_Render();
+		FPAD_Update();
+		if (delay > ticks_to_millisecs(gettime())) continue;
+		if (FPAD_Start(1)) {
+			ClearScreen();
+					if (which_bg == BG_NONE)
+					{PrintFormat(DEFAULT_SIZE, BLACK, 212, 232, "Returning to loader...");}
+					else if (which_bg == BG_LEGACY)
+					{PrintFormat(DEFAULT_SIZE, WHITE, 212, 232, "Returning to loader...");}
+			ExitToLoader(0);
+		}
+		if (FPAD_OK(1)) {
+			f_chdir_char("/apps/Nintendont");
+			if (selected == (DOWNLOAD_APPTHEME))
+				UpdateThemes();
+			if (selected == (DOWNLOAD_LOADERTHEME))
+				UpdateLoader();	
+			if (selected == (DOWNLOAD_LEGACYTHEME))
+				UpdateLegacy();	
+			if (selected == (DOWNLOAD_DEFAULTTHEME))
+				{f_unlink_char("./NinBackLight.png");
+				f_unlink_char("./NinBackDark.png");
+				f_unlink_char("./NinBackBars.png");
+				f_unlink_char("./NinBackNoBar.png");
+				f_unlink_char("./NinLegacy.png");				
+				f_unlink_char("./NinBack.png");
+				f_unlink_char("./NinBlack.png");
+				background = GRRLIB_LoadTexturePNG(background_png);
+				which_bg = BG_NONE;
+				UpdateNintendont();}	
+			if (selected == (DOWNLOAD_BIOS))
+				UpdateBios();
+			if (selected == (DOWNLOAD_OTHER))
+				UpdateOther();	
+			if (selected == (DOWNLOAD_SIMPLE))
+				SimpleBack();	
+			if (selected == (DOWNLOAD_SINGLE))
+				SingleBack();
+			if (selected == (DOWNLOAD_GRAD))
+				UpdateGrad();
+			if (selected == (DOWNLOAD_GAME))
+				GDMenu();
+			if (selected == (DOWNLOAD_BLACK))
+			{f_chdir_char("/apps/Nintendont");
+			f_unlink_char("./NinBackLight.png");
+			f_unlink_char("./NinBackDark.png");
+			f_unlink_char("./NinBackBars.png");
+			f_unlink_char("./NinBackNoBar.png");
+			f_unlink_char("./NinBlack.png");
+			Download(selected);
+			ClearScreen();		
+			if (which_bg == BG_NONE)
+			{
+			PrintFormat(25, BLACK, MENU_POS_X, MENU_POS_Y + 20*9, "Games Will Boot into a Black Screen Now");
+			PrintFormat(25, BLACK, MENU_POS_X, MENU_POS_Y + 20*11, "All Boot Messages & Info Will Be Hidden");
+			}
+			else if (which_bg == BG_LEGACY)
+			{
+			PrintFormat(25, WHITE, MENU_POS_X, MENU_POS_Y + 20*9, "Games Will Boot into a Black Screen Now");
+			PrintFormat(25, WHITE, MENU_POS_X, MENU_POS_Y + 20*11, "All Boot Messages & Info Will Be Hidden");
+			}
+			UpdateScreen();
+			sleep (5);
+			UpdateNintendont();}	
+			if (selected == (DOWNLOAD_VERSION))
+			{ExitBoot = 1;
+			return;}
+			if ((selected == (DOWNLOAD_OLD)) || (selected == (DOWNLOAD_NINTENDONT)))
+			{Download(selected);}
+			if (selected == (DOWNLOAD_NOOLD)){
+			if (prev == true)
+			f_rename_char( "/apps/Nintendont/Preview", "/apps/Nintendont/Previewz");
+			else
+			f_rename_char( "/apps/Nintendont/Previewz", "/apps/Nintendont/Preview");}		
+			else
+				break;}
+		if (FPAD_Down(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected++;
+			if (selected > 14) selected = 0;
+		}
+		if (FPAD_Up(1)) {
+			delay = ticks_to_millisecs(gettime()) + 150;
+			selected--;
+			if (selected < 0) selected = 14;
+		}
+		if(FPAD_Y(0)) {
+				Credits();
+		}
+		if (FPAD_Cancel(1)) 
+		{ExitBoot = 1;
+		break;}
+	}
+	ClearScreen();
+	return;
+}
\ No newline at end of file
 